﻿@using System.Web.Mvc
@using System.Web.Mvc.Html

@helper RoomCatalogItem(RoomEscapeCatalog.Models.Room room, bool createCrudControls = false)
{
    var page = PageContext.Page as System.Web.Mvc.WebViewPage;
    <div class="room">
        @page.Html.ActionLink(
            room.Name,
            nameof(RoomEscapeCatalog.Controllers.HomeController.RoomDetails),
            routeValues: new { roomName = room.NameID },
            htmlAttributes: new { @class = "name" })
        <div class="description">@room.ShortDescription</div>
        <div class="details">
            <div>Difficulty</div>
            <div>@room.Difficulty</div>
            <div>Group size</div>
            <div>@room.MinPlayers-@room.MaxPlayers</div>
            <div>Time limit</div>
            <div>@room.DurationMinutes min</div>
        </div>
        <span class="image" style="background-image: url('@page.Url.Content($"~/{room.Logo.Path}")')"></span>
        <div class="btn-container">
            @page.Html.ActionLink(
                "MORE INFO ❯",
                nameof(RoomEscapeCatalog.Controllers.HomeController.RoomDetails),
                "Home",
                routeValues: new { roomName = room.NameID },
                htmlAttributes: new { @class = "btn btn-outline-dark" })

            @if (createCrudControls)
            {
                @page.Html.ActionLink(
                "Edit",
                nameof(RoomEscapeCatalog.Controllers.AdminController.EditRoom),
                "Admin",
                routeValues: new { id = room.Id },
                htmlAttributes: new { @class = "btn btn-outline-dark" });

                @page.Html.ActionLink(
                "Delete",
                nameof(RoomEscapeCatalog.Controllers.AdminController.DeleteRoom),
                "Admin",
                routeValues: new { id = room.Id },
                htmlAttributes: new { @class = "btn btn-outline-danger btn-delete" });
            }
        </div>
    </div>
}


@helper Image(RoomEscapeCatalog.Models.ImageData image)
{
    var imageAbsolutePath = VirtualPathUtility.ToAbsolute($"~/{image.Path}");
    <img src="@imageAbsolutePath" alt="@image.Filename" />
}


@helper DeletableImage(RoomEscapeCatalog.Models.ImageData image, string propertyPrefix = null, string @class = null, string itemCollectionIndex = null)
{
    var imageAbsolutePath = VirtualPathUtility.ToAbsolute($"~/{image.Path}");
    var imgClass = @class == null ? "deletable-image" : $"deletable-image {@class}";

<div class="@imgClass">
    <img src="@imageAbsolutePath" alt="@image.Filename" />
    <span class="fas fa-times delete-image-btn" title="Delete"></span>

    @{
        var propId = nameof(image.Id);
        var propPath = nameof(image.Path);
        var propFilename = nameof(image.Filename);
        var propLogoOwnerRoomId = nameof(image.LogoOwnerRoomId);
        var propGalleryOwnerRoomId = nameof(image.GalleryOwnerRoomId);
        var hiddenInputNamePrefix = propertyPrefix;
        

        if (!String.IsNullOrWhiteSpace(itemCollectionIndex))
        {
            hiddenInputNamePrefix = $"{propertyPrefix}[{itemCollectionIndex}]";
        }

        if (!String.IsNullOrWhiteSpace(propertyPrefix))
        {
            propId = $"{hiddenInputNamePrefix}.{propId}";
            propPath = $"{hiddenInputNamePrefix}.{propPath}";
            propFilename = $"{hiddenInputNamePrefix}.{propFilename}";
            propLogoOwnerRoomId = $"{hiddenInputNamePrefix}.{propLogoOwnerRoomId}";
            propGalleryOwnerRoomId = $"{hiddenInputNamePrefix}.{propGalleryOwnerRoomId}";
        }
    }

    @if (!String.IsNullOrWhiteSpace(itemCollectionIndex))
    {
        var name = $"{propertyPrefix}.Index";
        <input type="hidden" name="@name" value="@itemCollectionIndex" />
    }
    <input type="hidden" name="@propId" value="@image.Id" />
    <input type="hidden" name="@propPath" value="@image.Path" />
    <input type="hidden" name="@propFilename" value="@image.Filename" />
    <input type="hidden" name="@propLogoOwnerRoomId" value="@image.LogoOwnerRoomId" />
    <input type="hidden" name="@propGalleryOwnerRoomId" value="@image.GalleryOwnerRoomId" />
</div>
}

